/* WCECheckboxPeer.java
   Copyright (C) 2005 Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce;

import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ItemEvent;
import java.awt.peer.CheckboxPeer;

public class WCECheckboxPeer extends WCEComponentPeer implements CheckboxPeer {
	WCECheckboxPeer(Checkbox checkbox) {
		super(checkbox);
		setLabel(checkbox.getLabel());
		setState(checkbox.getState());
	}
	
	protected int createNative(int hParentWnd, int x, int y, int width, int height) {
		Checkbox cb = (Checkbox) getComponent();
		CheckboxGroup group = cb.getCheckboxGroup();
		return createNativeCheckbox(hParentWnd, x, y, width, height, group);
	}
	
	private native int createNativeCheckbox(int hParentWnd, int x, int y, int width, int height, CheckboxGroup checkBoxGroup);

	public void setCheckboxGroup (CheckboxGroup group) {
		setNativeCheckboxGroup(getWindowHandle(), group);
	}
	
	private native void setNativeCheckboxGroup(int windowHandle, CheckboxGroup group);

	public void setLabel(String label) {
		setNativeText(getWindowHandle(), label);
	}

	public void setState (boolean state) {
		int windowHandle = getWindowHandle();
		boolean old = getNativeState(windowHandle);
		if (old != state) {
			// 状態が変化する場合
			setNativeState(windowHandle, state);
			Checkbox cb = (Checkbox) getComponent();
			CheckboxGroup group = cb.getCheckboxGroup();
			if (state && group != null && group.getSelectedCheckbox() != cb) {
				// ステータスが false -> true に変化する場合
				// CheckboxGroupの状態を変更する
				group.setSelectedCheckbox(cb);
			} else {
				cb.setState(state);
			}
		}
	}
	
	/**
	 * ItemEventを送信する
	 */
	void postItemEvent(boolean state) {
		Checkbox cb = (Checkbox) getComponent();
		ItemEvent e = new ItemEvent(cb,
									ItemEvent.ITEM_STATE_CHANGED,
									cb.getLabel(),
									(state ? ItemEvent.SELECTED : ItemEvent.DESELECTED));
		EventQueue queue = cb.getToolkit().getSystemEventQueue();
		queue.postEvent(e);
	}
	
	protected native Dimension getNativePreferredSize(int windowHandle);
	private native boolean getNativeState(int windowHandle);
	private native void setNativeState(int windowHandle, boolean state);
}
